SystemOrganization addCategory: #'AL-Serialization-Core'!

!CompiledMethod methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeExternally: self! !

!Boolean methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeSingleton: self! !

!Boolean methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ self! !

!Boolean methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!UndefinedObject methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	^ anEncoder encodeSingleton: self! !

!UndefinedObject methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ self! !

!UndefinedObject methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	^ aSerializer serializePrimitive: self! !

!WideString methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeUtf16String: self! !

!WideString methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!Integer methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeInteger: self! !

!Integer methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ self! !

!Integer methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!MethodContext methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
closure: aBlockClosure
	closureOrNil := aBlockClosure! !

!MethodContext methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeContext: self! !

!MethodContext methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeContext: self! !

!MethodContext methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	^ aSerializer serializeMethodContext: self! !

!Float methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeFloat: self! !

!Float methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ self! !

!Float methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	^ aSerializer serializePrimitive: self! !

!ContextPart class methodsFor: '*al-serialization-creation' stamp: 'cwp 3/11/2012 21:51'!
smBasicNew: anInteger
	^super basicNew: anInteger! !

!Dictionary methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	self class = Dictionary 
		ifTrue: [anEncoder encodeDictionary: self]
		ifFalse: [super encodeWith: anEncoder].! !

!Dictionary methodsFor: '*al-serialization-indexing' stamp: 'cwp 3/11/2012 21:51'!
indexOf: anObject do: aBlock
	self indexOf: anObject ifPresent: aBlock ifAbsent: aBlock! !

!Dictionary methodsFor: '*al-serialization-indexing' stamp: 'cwp 3/11/2012 21:51'!
indexOf: anObject ifPresent: pBlock ifAbsent: aBlock
	| id |
	(self includesKey: anObject)
		ifTrue: [ 
			id := self at: anObject.
			pBlock value: id ]
		ifFalse: [ 
			id := self size + 1.
			self at: anObject put: id.
			aBlock value: id ]! !

!Dictionary methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeDictionary: self! !

!Dictionary methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	^ aSerializer serializeDictionary: self! !

!IdentityDictionary methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeIdentityDictionary: self! !

!Symbol methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeSymbol: self! !

!Symbol methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!String methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: anObject
	^ self! !

!ByteArray methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	^ self class = ByteArray 
		ifTrue: [anEncoder encodeByteArray: self]
		ifFalse: [super encodeWith: anEncoder]! !

!ByteArray methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeBytes: self! !

!ByteArray methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!Behavior methodsFor: '*al-serialization-accessing' stamp: 'cwp 3/11/2012 21:51'!
smFormatCode
	self isFixed ifTrue: [^ 1].		"named pointers only"
	self isPointers ifTrue: [^ 2].		"named pointers + index pointers"
	self isBytes ifTrue: [^ 3].		"bytes"
	self isWords ifTrue: [^ 4].		"words"
	self isWeak ifTrue: [^ 5].		"weak"
	self error: 'Unsupported class format.'! !

Object subclass: #ALArchive
	instanceVariableNames: 'bytes external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALArchive class methodsFor: 'instance creation' stamp: 'cwp 8/26/2010 10:02'!
bytes: aByteArray external: anArray
	^ self basicNew
		initializeWithBytes: aByteArray external: anArray;
		yourself! !

!ALArchive class methodsFor: 'serializing' stamp: 'cwp 3/11/2012 21:34'!
with: anObject
	| ext stream |
	stream := (ByteArray new: 100) writing.
	ext := ALSerializer serialize: anObject on: stream.
	^ self bytes: stream contents external: ext! !

!ALArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2008 23:57'!
bytes
	^ bytes! !

!ALArchive methodsFor: 'as yet unclassified' stamp: 'cwp 3/10/2012 20:38'!
digest
	| stream |
	stream := nil writing hashing: 'sha1'.
	stream write: bytes.
	^ stream digest! !

!ALArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:01'!
external
	^ external! !

!ALArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:02'!
initializeWithBytes: aByteArray external: anArray
	self initialize.
	bytes := aByteArray.
	external := anArray! !

!ALArchive methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
materialize
	^ (ALMaterializer on: bytes reading)
		external: external;
		materialize! !

Object subclass: #ALCodec
	instanceVariableNames: 'stream classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALCodec methodsFor: 'initialize-release' stamp: 'cwp 9/9/2010 23:02'!
initializeWithStream: aStream
	self initialize.
	stream := aStream! !

ALCodec subclass: #ALDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2011 15:08'!
stream: aStream
	^ self basicNew initializeWithStream: aStream! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/9/2010 20:15'!
classNamed: aSymbol format: anInteger instVars: anArray
	| escape class |
	escape := [^ self stubNamed: aSymbol format: anInteger instVars: anArray].
	class := Smalltalk at: aSymbol ifAbsent: escape.
	class smFormatCode = anInteger ifFalse: escape.
	anInteger < 3 ifTrue: [class allInstVarNames = anArray ifFalse: escape].
	^ class! !

!ALDecoder methodsFor: 'public' stamp: 'cwp 8/7/2011 15:41'!
decode
	| type |
	type := self getType.
	type < 241 ifTrue: [^ type].
	type = 255 ifTrue: [^ self decodeArrow].
	type = 254 ifTrue: [^ self decodeExternal].
	type = 253 ifTrue: [^ self decodeClass].
	type = 252 ifTrue: [^ self decodeObject].
	type = 251 ifTrue: [^ self decodeUtf8String].
	type = 250 ifTrue: [^ self decodeUtf16String].
	type = 249 ifTrue: [^ self decodeSymbol].
	type = 248 ifTrue: [^ self decodeLargeNegativeInteger].
	type = 247 ifTrue: [^ self decodeSmallNegativeInteger].
	type = 246 ifTrue: [^ self decodeSmallPositiveInteger].
	type = 245 ifTrue: [^ self decodeLargePositiveInteger].
	type = 244 ifTrue: [^ self decodeFloat].
	type = 243 ifTrue: [^ self decodeContext].
	type = 242 ifTrue: [^ self decodeLibrary].
	type = 241 ifTrue: [^ self decodeCompact].
! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/8/2011 23:43'!
decodeArray
	^ Array new: self decode.! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 3/11/2012 21:34'!
decodeArrow
	^ ALArrow with: self decode.! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 15:16'!
decodeBag
	^ Bag new! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 3/7/2012 00:31'!
decodeByteArray
	| bytes |
	bytes := ByteArray new: self decode.
	self getBytesInto: bytes.
	^ bytes! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/9/2011 15:16'!
decodeClass
	| id names code class |
	id := self decode.
	^ id isInteger
		ifTrue: [classes at: id]
		ifFalse:
			[code := self decode.
			code < 3 ifTrue:
				[names := Array new:  self decode.
				1 to: names size do: [:index | names at: index put: self decode]].
			class := self classNamed: id format: code instVars: names.
			classes add: class]! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/7/2011 15:49'!
decodeContext
	| frameSize |
	frameSize := self decode.
	^ MethodContext smBasicNew: frameSize.! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:40'!
decodeDictionary
	^ Dictionary new
! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 3/11/2012 21:34'!
decodeExternal
	^ ALExternal with: self decode.! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:45'!
decodeFloat
	^ self getFloat! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 16:12'!
decodeIdentityDictionary
	^ IdentityDictionary new
! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/3/2011 16:27'!
decodeInterval
	^ Interval new! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:42'!
decodeLargeNegativeInteger
	| size |
	size := self decode.
	^ (self getIntegerOfSize: size) negated! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:41'!
decodeLargePositiveInteger
	| size |
	size := self decode.
	^ self getIntegerOfSize: size! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/8/2011 23:41'!
decodeLibrary
	| type |
	type := self decode.
	type = 1 ifTrue: [^ nil].
	type = 2 ifTrue: [^ true].
	type = 3 ifTrue: [^ false].
	type = 4 ifTrue: [^ self decodeArray].
	type = 5 ifTrue: [^ self decodeBag].
	type = 6 ifTrue: [^ self decodeByteArray].
	type = 7 ifTrue: [^ self decodeDictionary].
	type = 8 ifTrue: [^ self decodeIdentityDictionary].
	type = 9 ifTrue: [^ self decodeInterval].
	type = 10 ifTrue: [^ self decodeOrderedCollection].
	type = 11 ifTrue: [^ self decodeSet].
	self error: 'unrecognized library type'! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 3/7/2012 00:26'!
decodeObject
	| theClass |
	theClass := self decode.
	^ theClass isVariable 
		ifTrue: 
			[ | object |
			object := theClass basicNew: self decode.
			theClass isBits ifTrue: [self getBytesInto: object].
			object]
		ifFalse: 
			[theClass basicNew].
	! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 10/4/2011 11:29'!
decodeOrderedCollection
	^ OrderedCollection new! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:28'!
decodeSet
	^ Set new! !

!ALDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 13:07'!
decodeSingleton
	^ self getSingleton! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallNegativeInteger
	^ self getSmallInteger negated! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallPositiveInteger
	^ self getSmallInteger! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:30'!
decodeSymbol
	^ self decodeUtf8String asSymbol! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/8/2011 23:42'!
decodeUtf16String
	| size |
	size := self decode.
	^ self getUtf16StringOfSize: size.
	! !

!ALDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/7/2011 16:11'!
decodeUtf8String
	| size |
	size := self decode.
	^ self getUtf8StringOfSize: size! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream get ]! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:52'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream get].
	^ value! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
getSmallInteger
	| hi lo |
	hi := stream get.
	lo := stream get.
	^ (hi bitShift: 8) + lo! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:50'!
getType
	^ stream get! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!ALDecoder methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 15:15'!
initialize
	classes := OrderedCollection new! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:22'!
nextPut: aByte! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
readTwoBytes
	| hi lo |
	hi := stream get.
	lo := stream get.
	^ (hi bitShift: 8) bitOr: lo! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 10/3/2011 14:53'!
readUtf8Character
	| value |
	value := stream get.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream get bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream get bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream get bitAnd: 63)].
			^ Unicode value: value ]! !

!ALDecoder methodsFor: 'private' stamp: 'cwp 9/9/2010 20:13'!
stubNamed: aSymbol format: anInteger instVars: anArray
	self shouldBeImplemented! !

ALCodec subclass: #ALEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

ALEncoder class
	instanceVariableNames: 'stream'!

ALEncoder class
	instanceVariableNames: 'stream'!

!ALEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2011 16:05'!
stream: aStream
	^ self basicNew initializeWithStream: aStream! !

!ALEncoder methodsFor: 'public' stamp: 'cwp 8/26/2010 10:33'!
encode: anObject
	anObject encodeWith: self! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/7/2011 14:08'!
encodeArray: anArray
	self writeLibraryType.
	self writeArrayType.
	self encodeInteger: anArray size! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeArrow: anArrow
	self writeArrowType.
	self encodeInteger: anArrow index! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 15:15'!
encodeBag: aBag
	self writeLibraryType.
	self writeBagType.! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 3/7/2012 00:30'!
encodeByteArray: anArray
	self writeLibraryType.
	self writeByteArrayType.
	self encodeInteger: anArray size.
	self encodeBytesFrom: anArray! !

!ALEncoder methodsFor: 'public' stamp: 'cwp 10/3/2011 15:03'!
encodeBytesFrom: anObject
	1 to: anObject byteSize do: 
		[:index | stream put: (anObject byteAt: index)]! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/9/2011 15:13'!
encodeClass: aClass
	| code |
	self writeClassType.
	classes 
		indexOf: aClass
		ifPresent: [:index | self encodeInteger: index]
		ifAbsent:
			[:index |
			self encodeSymbol: aClass name.
			self encodeInteger: (code := aClass smFormatCode).
			code < 3 ifTrue: 
				[ | names |
				names := aClass allInstVarNames.
				self encodeInteger: names size.
				names do: [ :ea | self encodeUtf8String: ea ] ] ]
		
! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 15:47'!
encodeContext: aMethodContext
	self writeContextType.
	self encodeInteger: aMethodContext method frameSize! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/7/2011 14:09'!
encodeDictionary: aDictionary
	self writeLibraryType.
	self writeDictionaryType.
	self encodeInteger: aDictionary size! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 3/6/2012 23:35'!
encodeExternal: anExternal
	self writeExternalType.
	self encodeInteger: anExternal index! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeFloat: aFloat
	self writeFloatType.
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2)! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 16:11'!
encodeIdentityDictionary: aDictionary
	self writeLibraryType.
	self writeIdentityDictionaryType.
	self encodeInteger: aDictionary size! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 20:27'!
encodeInteger: anInteger
	anInteger < -65535 ifTrue: 
		[self writeLargeNegativeIntegerType.
		^ self writeLargeInteger: anInteger negated].
	anInteger < 0 ifTrue: 
		[self writeSmallNegativeIntegerType.
		^ self writeSmallInteger: anInteger negated].
	anInteger < 242 ifTrue: 
		[ ^ self writeTinyInteger: anInteger ].
	anInteger < 65535 ifTrue: 
		[self writeSmallPositiveIntegerType.
		^ self writeSmallInteger: anInteger].
	self writeLargePositiveIntegerType.
	self writeLargeInteger: anInteger! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 16:27'!
encodeInterval: anInterval 
	self writeLibraryType.
	self writeIntervalType.
	! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 3/7/2012 00:12'!
encodeObject: anObject
	self writeObjectType.
	self encodeClass: anObject class.
	anObject class isVariable ifTrue: 
		[self encodeInteger: anObject basicSize.
		anObject class isBits ifTrue:
			[self encodeBytesFrom: anObject]]! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/4/2011 11:29'!
encodeOrderedCollection: anOrderedCollection 
	self writeLibraryType.
	self writeOrderedCollectionType.! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 20:17'!
encodeSet: aSet
	self writeLibraryType.
	self writeSetType.! !

!ALEncoder methodsFor: 'encoding - library' stamp: 'cwp 10/3/2011 15:04'!
encodeSingleton: aBoolean
	| index |
	self writeLibraryType.
	index := #(nil true false) indexOf: aBoolean.
	stream put: index! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeSymbol: aSymbol
	self writeSymbolType.
	self encodeInteger: aSymbol size.
	self writeUtf8String: aSymbol! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:11'!
encodeUtf16String: aString
	self writeUtf16Type.
	self encodeInteger: aString size.
	self writeUtf16String: aString! !

!ALEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/7/2011 14:09'!
encodeUtf8String: aString
	self writeUtf8Type.
	self encodeInteger: aString size.
	self writeUtf8String: aString! !

!ALEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 14:46'!
initialize
	classes := IdentityDictionary new! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:03'!
write32BitInteger: anInteger
	stream		
		put: (anInteger bitShift: -24);
		put: ((anInteger bitShift: -16) bitAnd: 255);
		put: ((anInteger bitShift: -8) bitAnd: 255);
		put: (anInteger bitAnd: 255)! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:02'!
writeArrayType
	stream put: 4! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:03'!
writeArrowType
	stream put: 255! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:15'!
writeBagType
	stream put: 5! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:02'!
writeByteArrayType
	stream put: 6! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:00'!
writeClassType
	stream put: 253! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/4/2011 16:15'!
writeCompactType
	stream put: 241! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/4/2011 11:21'!
writeContextType
	stream put: 243! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:03'!
writeDictionaryType
	stream put: 7! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeExternalType
	stream put: 254! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:03'!
writeFloatType
	stream put: 244! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/4/2011 15:36'!
writeFourByteCode: anInteger
	| value |
	value := anInteger - 16r10000.
	stream put: ((value bitShift: -18) bitOr: 16rD8).
	stream put: ((value bitShift: -10) bitAnd: 16rFF).
	stream put: ((value bitShift: -8) bitOr: 16rDC).
	stream put: (value bitAnd: 16rFF).
	

! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 16:11'!
writeIdentityDictionaryType
	stream put: 8! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 16:25'!
writeIntervalType
	stream put: 9! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:04'!
writeLargeInteger: anInteger
	| byte size |
	size := (anInteger log: 256) floor + 1.
	self encodeInteger: size.
	(size - 1 to: 0 by: -1)
		do: [ :index | 
			byte := (anInteger bitShift: index * -8) bitAnd: 255.
			stream put: byte ]! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:04'!
writeLargeNegativeIntegerType
	stream put: 248! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:04'!
writeLargePositiveIntegerType
	stream put: 245! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 2/17/2012 13:20'!
writeLibraryType
	stream write: 242! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeObjectType
	stream put: 252! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/4/2011 11:29'!
writeOrderedCollectionType
	stream put: 10! !

!ALEncoder methodsFor: 'types - library' stamp: 'cwp 10/3/2011 15:04'!
writeSetType
	stream put: 11! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:03'!
writeSmallInteger: anInteger
	stream put: (anInteger bitShift: -8).
	stream put: (anInteger bitAnd: 255). ! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:05'!
writeSmallNegativeIntegerType
	stream put: 247! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:02'!
writeSmallPositiveIntegerType
	stream put: 246! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:00'!
writeSymbolType
	stream put: 249! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:00'!
writeTinyInteger: anInteger
	stream put: anInteger! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/3/2011 15:05'!
writeTwoByteCode: value
	stream put: (value bitShift: -8).
	stream put: (value bitAnd: 16rFF).! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:07'!
writeUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:05'!
writeUtf16Type
	stream put: 250! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 10/4/2011 16:14'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream put: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream put: ((value bitShift: -6) bitOr: 16rC0).
					stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream put: ((value bitShift: -12) bitOr: 16rE0).
							stream put: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]
						ifFalse:
							[stream put: ((value bitShift: -18) bitOr: 16rF0).
							stream put: (((value bitShift: -12) bitAnd: 16r3F) bitOr: 16r80).
							stream put: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream put: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

!ALEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!ALEncoder methodsFor: 'types - base' stamp: 'cwp 10/3/2011 15:06'!
writeUtf8Type
	stream put: 251! !

Object subclass: #ALIndex
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

ALIndex subclass: #ALArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:36'!
encodeWith: anEncoder
	anEncoder encodeArrow: self! !

!ALArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:05'!
materializeWith: aMaterializer
	^ aMaterializer materializeArrow: self! !

ALIndex subclass: #ALExternal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:39'!
encodeWith: anEncoder
	anEncoder encodeExternal: self! !

!ALExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:44'!
materializeWith: aMaterializer
	^ aMaterializer materializeExternal: self! !

!ALIndex class methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
with: anInteger
	^ self basicNew
		initializeWithIndex: anInteger;
		yourself! !

!ALIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
encodeWith: anEncoder
	self subclassResponsibility! !

!ALIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
index
	^ index! !

!ALIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
initializeWithIndex: anInteger
	self initialize.
	index := anInteger.
	! !

Object subclass: #ALMaterializer
	instanceVariableNames: 'decoder internal external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALMaterializer class methodsFor: 'instance creation' stamp: 'cwp 8/9/2011 15:20'!
decoder: aDecoder
	^ self basicNew initializeWithDecoder: aDecoder! !

!ALMaterializer class methodsFor: 'materializing' stamp: 'cwp 10/3/2011 14:52'!
materialize: aByteArray
	^ self materializeFrom: aByteArray reading! !

!ALMaterializer class methodsFor: 'materializing' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!ALMaterializer class methodsFor: 'instance creation' stamp: 'cwp 3/11/2012 21:34'!
on: aReadStream
	^ self decoder: (ALDecoder stream: aReadStream)! !

!ALMaterializer methodsFor: 'public' stamp: 'cwp 8/26/2010 10:04'!
external: anArray 
	
	external := anArray! !

!ALMaterializer methodsFor: 'initialize-release' stamp: 'cwp 8/9/2011 15:18'!
initializeWithDecoder: aDecoder
	self initialize.
	decoder := aDecoder.
	internal := OrderedCollection new! !

!ALMaterializer methodsFor: 'public' stamp: 'cwp 8/9/2011 15:22'!
materialize
	| object |
	object := decoder decode.
	^ object materializeWith: self.
	! !

!ALMaterializer methodsFor: 'public' stamp: 'cwp 3/6/2012 20:13'!
materialize: anObject with: aBlock
	internal add: anObject.
	aBlock value.
	^ anObject! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/6/2012 20:13'!
materializeArray: anArray
	^ self materialize: anArray with: [self readPointersInto: anArray]
	! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:06'!
materializeArrow: anArrow
	^ internal at: anArrow index! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 10/3/2011 15:22'!
materializeBag: aBag 
	| size |
	size := self materialize.
	size timesRepeat: [aBag add: self materialize].
	^ aBag! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/7/2012 00:33'!
materializeBytes: aBytesObject
	^ self 
		materialize: aBytesObject
		with: []! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 8/9/2011 15:22'!
materializeClass: aClass
	internal add: aClass.
	^ aClass! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/6/2012 20:15'!
materializeContext: aContext
	| sender pc stackp closure receiver method |
	^ self materialize: aContext with:
		[method := self materialize.
		sender := self materialize.
		pc := self materialize.
		stackp := self materialize.
		closure := self materialize.
		receiver := self materialize.
		aContext
			setSender: sender
				receiver: receiver
				method: method
				arguments: #();
			pc: pc;
			stackp: stackp;
			closure: closure.
		self readPointersInto: aContext]! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/6/2012 20:15'!
materializeDictionary: aDictionary
	| size |
	^ self materialize: aDictionary with:
		[size := self materialize.
		size timesRepeat: [ aDictionary at: self materialize put: self materialize]]! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:44'!
materializeExternal: anExternal
	^ external at: anExternal index! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 10/3/2011 16:29'!
materializeInterval: anInterval 
	anInterval
		setFrom: self materialize
		to: self materialize
		by: self materialize.
	^ anInterval ! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/7/2012 00:15'!
materializeObject: anObject
	^ self materialize: anObject with:
		[1 to: anObject class instSize do: [ :i | anObject instVarAt: i put: self materialize].
		anObject class isVariable ifTrue: 
			[anObject class isPointers
				ifTrue: [self readPointersInto: anObject]]]! !

!ALMaterializer methodsFor: 'materializing' stamp: 'cwp 3/6/2012 20:17'!
materializeSet: aSet
	| size |
	^ self materialize: aSet with:
		[size := self materialize.
		size timesRepeat: [aSet add: self materialize]]! !

!ALMaterializer methodsFor: 'private' stamp: 'cwp 9/10/2010 00:03'!
readPointersInto: anObject 
	
	1	to: anObject basicSize
		do:	[ :i | anObject basicAt: i put: self materialize ]! !

Object subclass: #ALReference
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALReference class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:40'!
to: anObject
	^ self new
		value: anObject;
		yourself! !

!ALReference methodsFor: 'serialization' stamp: 'cwp 8/26/2010 10:14'!
serializeWith: aSerializer
	^ aSerializer serializeReference: self! !

!ALReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:38'!
value
	^ value! !

!ALReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:40'!
value: anObject
	^ value := anObject! !

Object subclass: #ALSerializer
	instanceVariableNames: 'encoder external internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Serialization-Core'!

!ALSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/7/2011 16:07'!
encoder: anEncoder
	^ self basicNew initializeWithEncoder: anEncoder! !

!ALSerializer class methodsFor: 'instance creation' stamp: 'cwp 3/11/2012 21:34'!
on: aWriteStream
	| anEncoder |
	anEncoder := ALEncoder stream: aWriteStream.
	^ self encoder: anEncoder! !

!ALSerializer class methodsFor: 'serializing' stamp: 'cwp 3/11/2012 21:34'!
serialize: anObject
	| ext stream |
	stream := (ByteArray new: 100) writing.
	ext := ALSerializer serialize: anObject on: stream.
	ext isEmpty ifFalse: [self error: 'This object refers to unserializable objects'].
	^ stream contents! !

!ALSerializer class methodsFor: 'serializing' stamp: 'cwp 3/11/2012 21:34'!
serialize: anObject external: aDictionary
	| stream external |
	stream := (ByteArray new: 100) writing.
	external := self serialize: anObject external: aDictionary on: stream.
	^ ALArchive bytes: stream contents external: external! !

!ALSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject external: aDictionary on: aWriteStream
	^ (self on: aWriteStream)
		external: aDictionary;
		serialize: anObject;
		external! !

!ALSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject on: aWriteStream
	^ self 
		serialize: anObject 
		external: IdentityDictionary new 
		on: aWriteStream! !

!ALSerializer methodsFor: 'public' stamp: 'cwp 10/3/2011 16:21'!
encode: anObject
	encoder encode: anObject! !

!ALSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external
	| array |
	array := Array new: external size.
	external keysAndValuesDo:
		[:object :i | array at: i put: object].
	^ array! !

!ALSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external: aDictionary
	external := aDictionary! !

!ALSerializer methodsFor: 'initialize-release' stamp: 'cwp 8/6/2011 19:30'!
initializeWithEncoder: anEncoder
	encoder := anEncoder.
	internal := IdentityDictionary new.
	external := IdentityDictionary new! !

!ALSerializer methodsFor: 'public' stamp: 'cwp 8/31/2008 21:21'!
serialize: anObject
	anObject serializeWith: self! !

!ALSerializer methodsFor: 'public' stamp: 'cwp 3/11/2012 21:34'!
serialize: anObject with: aBlock
	internal 
		indexOf: anObject
		ifPresent: [ :id | encoder encode: (ALArrow with: id) ] 
		ifAbsent: [ :id | aBlock value ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 9/9/2010 23:14'!
serializeArray: anArray
	self serialize: anArray with: 
		[encoder encode: anArray.
		anArray do: [ :ea | self serialize: ea ] ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 10/3/2011 15:18'!
serializeBag: aBag
	self serialize: aBag with: 
		[encoder encode: aBag.
		self serialize: aBag size.
		aBag do: [ :ea | self serialize: ea ] ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 8/9/2011 15:23'!
serializeClass: aClass
	self 
		serialize: aClass 
		with: [encoder encode: aClass]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 10/3/2011 16:08'!
serializeDictionary: aDictionary
	self serialize: aDictionary with: 
		[encoder encode: aDictionary.
		aDictionary keys asArray sort do: 
			[ :key | 
			self serialize: key.
			self serialize: (aDictionary at: key) ] ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 3/11/2012 21:34'!
serializeExternally: anObject
	external 
		indexOf: anObject 
		do: [ :index | encoder encode: (ALExternal with: index) ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 3/6/2012 23:25'!
serializeMethodContext: aContext
	self serialize: aContext with: 
		[encoder encode: aContext.
		self serialize: aContext method.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext stackPtr.
		self serialize: aContext closure.
		self serialize: aContext receiver.
		self writePointersFrom: aContext ]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 3/7/2012 00:14'!
serializeObject: anObject
	self serialize: anObject with: 
		[encoder encode: anObject.
		1 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)].
		anObject class isVariable ifTrue: 
			[anObject class isPointers ifTrue: 
				[self writePointersFrom: anObject]]]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 3/6/2012 23:09'!
serializePrimitive: anObject
	encoder encode: anObject! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 3/6/2012 23:37'!
serializeReference: aReference
	self serialize: aReference with:
		[encoder encode: aReference.
		self serializeExternally: aReference value]! !

!ALSerializer methodsFor: 'serializing' stamp: 'cwp 10/4/2011 11:33'!
serializeSet: aSet
	self serialize: aSet with: 
		[encoder encode: aSet.
		self serialize: aSet size.
		aSet do: [ :ea | self serialize: ea ] ]! !

!ALSerializer methodsFor: 'private' stamp: 'cwp 9/9/2010 23:55'!
writePointersFrom: anObject
	1 to: anObject basicSize do: [ :i | self serialize: (anObject basicAt: i)]
	! !

!Object methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeObject: self! !

!Object methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeObject: self! !

!Object methodsFor: '*al-serialization-public' stamp: 'cwp 3/11/2012 21:51'!
rematerialize
	^ self serialize materialize! !

!Object methodsFor: '*al-serialization-public' stamp: 'cwp 3/11/2012 21:51'!
serialize
	^ ALArchive with: self! !

!Object methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeObject: self! !

!Bag methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	^ anEncoder encodeBag: self! !

!Bag methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeBag: self! !

!Bag methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeBag: self! !

!Class methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeClass: self! !

!Class methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeClass: self! !

!Class methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeClass: self! !

!ByteString methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeUtf8String: self! !

!ByteString methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializePrimitive: self! !

!Interval methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	^ anEncoder encodeInterval: self! !

!Interval methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeInterval: self! !

!Interval methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer
		encode: self;
		serialize: start;
		serialize: stop;
		serialize: step! !

!Array methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	^ anEncoder encodeArray: self! !

!Array methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeArray: self! !

!Array methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeArray: self! !

!OrderedCollection methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeOrderedCollection: self! !

!OrderedCollection methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeSet: self    ! !

!OrderedCollection methodsFor: '*al-serialization-dispatching' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	aSerializer serializeSet: self  ! !

!Set methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
encodeWith: anEncoder
	anEncoder encodeSet: self! !

!Set methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
materializeWith: aMaterializer
	^ aMaterializer materializeSet: self! !

!Set methodsFor: '*al-serialization-dispatch' stamp: 'cwp 3/11/2012 21:51'!
serializeWith: aSerializer
	^ aSerializer serializeSet: self! !
